diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index ef2411cfe..b7ee32021 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -34,6 +34,8 @@ import net.minecraft.client.gui.server.ScreenSelectServer;
 import net.minecraft.client.gui.toasts.GuiElementToastsHud;
 import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.player.controller.PlayerControllerSP;
+import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
+import net.minecraft.client.world.chunk.provider.ChunkProviderThreadedClient;
 import net.minecraft.client.world.save.SaveHandlerClientSP;
 import net.minecraft.core.net.CertificateHelper;
 import net.minecraft.client.net.handler.PacketHandlerClient;
@@ -86,6 +88,7 @@ import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.LoggedPrintStream;
 import net.minecraft.core.util.helper.UUIDHelper;
+import net.minecraft.core.world.chunk.provider.ChunkProviderThreaded;
 import net.minecraft.core.world.save.SaveFormatBase;
 import net.minecraft.core.world.settings.WorldConfiguration;
 import net.minecraft.core.world.type.WorldType;
@@ -675,6 +678,7 @@ public class Minecraft
         	// This thing takes forever to load, so it has been moved down here,
         	// so that the loading time is spent on the loading screen and not a black screen
             rpcThread = new RichPresenceHandlerThread(this);
+            rpcThread.setName("Discord RPC Thread");
             rpcThread.start();
         }
 
@@ -841,7 +845,16 @@ public class Minecraft
     @Override
     public IChunkProvider createChunkProvider(World world, IChunkLoader chunkLoader)
     {
-        return new ChunkProviderStatic(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
+        return switch (gameSettings.enableThreadedChunkProvider.value) {
+            case DYNAMIC ->
+                new ChunkProviderDynamic(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
+
+            case THREADED ->
+                 new ChunkProviderThreadedClient(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
+
+            default ->
+                new ChunkProviderStatic(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
+        };
     }
 
     public static File getAppDir(String s)
@@ -1904,6 +1917,12 @@ public class Minecraft
                     throw t;
                 }
                 Debug.change("misc");
+            } else {
+                try {
+                    currentWorld.getChunkProvider().tick();
+                } catch (Throwable throwable) {
+                    LOGGER.error("Issue while ticking chunk provider!", throwable);
+                }
             }
             if(!isGamePaused && currentWorld != null)
             {
@@ -2451,6 +2470,7 @@ public class Minecraft
                 }
                 currentWorld.getChunkProvider().unloadAllChunks();
                 currentWorld.onUnload();
+                currentWorld.close();
                 if (player != null) {
                     currentWorld.saveHandler.save(player);
                 }
@@ -2587,9 +2607,21 @@ public class Minecraft
             {
                 loadingScreen.progressStagePercentage((i++ * 100) / j);
                 currentWorld.getBlockId(chunkcoordinates.x + k, 64, chunkcoordinates.z + l);
-                while(currentWorld.updatingLighting()) ;
             }
+        }
+        loadingScreen.progressStage("Updating Lights");
+        int count = this.currentWorld.getLightingEngine().pendingUpdates();
+
+        int v = 0;
+        while (currentWorld.updatingLighting()) {
+            v++;
+            loadingScreen.progressStagePercentage((Math.min(v, count) * 100) / count);
 
+            if (v >= 10000) {
+                LOGGER.error("Updating lights took to long panic skipping!");
+                Thread.dumpStack();
+                break;
+            }
         }
 
         loadingScreen.progressStage("Simulating world for a bit...");
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenPause.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenPause.java
index 38bcd3fd5..9b29bfa62 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenPause.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenPause.java
@@ -9,6 +9,7 @@ import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.util.helper.UrlHelper;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
+import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.lang.I18n;
@@ -16,82 +17,77 @@ import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.client.input.InputType;
 import org.jetbrains.annotations.NotNull;
 
-public class ScreenPause extends Screen
-{
-
-    public ScreenPause()
-    {
-        updateCounter2 = 0;
-        updateCounter = 0;
+public class ScreenPause extends Screen {
+    public static boolean photoModeDisabled = false;
+    private int tickCount;
+    private boolean saving = false;
+    public ScreenPause() {
+        this.tickCount = 0;
     }
 
     @Override
-	public void init()
-    {
+    public void init() {
+        this.saving = !this.mc.currentWorld.pauseScreenSave(this.tickCount);
         I18n i = I18n.getInstance();
-        updateCounter2 = 0;
-        buttons.clear();
+        this.buttons.clear();
         byte byte0 = -16;
-        buttons.add(new ButtonElement(1, width / 2 - 100, height / 4 + 120 + byte0, i.translateKey("gui.ingame_menu.button.save_and_quit")));
-        if(mc.isMultiplayerWorld())
-        {
-            buttons.get(0).displayString = i.translateKey("gui.ingame_menu.button.disconnect");
+        this.buttons.add(new ButtonElement(1, this.width / 2 - 100, this.height / 4 + 120 + byte0, i.translateKey("gui.ingame_menu.button.save_and_quit")));
+        if (this.mc.isMultiplayerWorld()) {
+            this.buttons.get(0).displayString = i.translateKey("gui.ingame_menu.button.disconnect");
         }
-        buttons.add(new ButtonElement(4, width / 2 - 100, height / 4 + 24 + byte0, i.translateKey("gui.ingame_menu.button.back_to_game")));
-        buttons.add(new ButtonElement(0, width / 2 - 100, height / 4 + 96 + byte0, 98, 20, i.translateKey("gui.ingame_menu.button.options")));
-        ButtonElement photoModeButton = new ButtonElement(7, width / 2 + 2, height / 4 + 96 + byte0, 98, 20, i.translateKey("gui.ingame_menu.button.photo_mode"));
-        buttons.add(photoModeButton);
-        if (photoModeDisabled)
-        {
+        this.buttons.add(new ButtonElement(4, this.width / 2 - 100, this.height / 4 + 24 + byte0, i.translateKey("gui.ingame_menu.button.back_to_game")));
+        this.buttons.add(new ButtonElement(0, this.width / 2 - 100, this.height / 4 + 96 + byte0, 98, 20, i.translateKey("gui.ingame_menu.button.options")));
+        ButtonElement photoModeButton = new ButtonElement(7, this.width / 2 + 2, this.height / 4 + 96 + byte0, 98, 20, i.translateKey("gui.ingame_menu.button.photo_mode"));
+        this.buttons.add(photoModeButton);
+        if (photoModeDisabled) {
             photoModeButton.enabled = false;
         }
-        buttons.add(new ButtonElement(5, width / 2 - 100, height / 4 + 48 + byte0, 98, 20, I18n.getInstance().translateKey("gui.ingame_menu.button.achievements")));
-        buttons.add(new ButtonElement(6, width / 2 + 2, height / 4 + 48 + byte0, 98, 20, I18n.getInstance().translateKey("gui.ingame_menu.button.statistics")));
-        ButtonElement debugButton = new ButtonElement(9, width - 8, height - 8, 8, 8, "");
+        this.buttons.add(new ButtonElement(5, this.width / 2 - 100, this.height / 4 + 48 + byte0, 98, 20, I18n.getInstance().translateKey("gui.ingame_menu.button.achievements")));
+        this.buttons.add(new ButtonElement(6, this.width / 2 + 2, this.height / 4 + 48 + byte0, 98, 20, I18n.getInstance().translateKey("gui.ingame_menu.button.statistics")));
+        ButtonElement debugButton = new ButtonElement(9, this.width - 8, this.height - 8, 8, 8, "");
         debugButton.visible = false;
-        buttons.add(debugButton);
-        buttons.add(new ButtonElement(10, width / 2 - 100 - 24, height / 4 + 120 + byte0, 20, 20, "")
+        this.buttons.add(debugButton);
+        this.buttons.add(new ButtonElement(10, this.width / 2 - 100 - 24, this.height / 4 + 120 + byte0, 20, 20, "")
             .setTextures("minecraft:gui/misc/button_support", "minecraft:gui/misc/button_support_highlighted", "minecraft:gui/misc/button_support"));
     }
 
     @Override
-	protected void buttonClicked(@NotNull ButtonElement button)
-    {
+    protected void buttonClicked(@NotNull ButtonElement button) {
         switch (button.id) {
             case 0:
-                mc.displayScreen(new ScreenOptions(this));
+                this.mc.displayScreen(new ScreenOptions(this));
                 break;
             case 1:
-                mc.statsCounter.add(StatList.leaveGameStat, 1);
-                if (mc.isMultiplayerWorld()) {
-                    mc.currentWorld.sendQuittingDisconnectingPacket();
+                this.mc.statsCounter.add(StatList.leaveGameStat, 1);
+                if (this.mc.isMultiplayerWorld()) {
+                    this.mc.currentWorld.sendQuittingDisconnectingPacket();
                     Registries.RECIPES = Registries.RECIPES_LOCAL_COPY;
                     GuidebookPageSearch.searchField.setText("");
                     GuidebookPageManager.searchQuery = SearchQuery.resolve(GuidebookPageSearch.searchField.getText());
                     ScreenGuidebook.getPageManager().updatePages();
                 }
-                mc.changeWorld(null);
-                mc.displayScreen(new ScreenMainMenu());
+                this.mc.changeWorld(null);
+                this.mc.displayScreen(new ScreenMainMenu());
                 break;
             case 4:
-                mc.displayScreen(null);
-                mc.setIngameFocus();
+                this.mc.displayScreen(null);
+                this.mc.setIngameFocus();
 
                 //Cancel A press so you dont jump because you hold the jump button
-                if (mc.inputType == InputType.CONTROLLER) mc.controllerInput.buttonA.cancelButtonPress();
+                if (this.mc.inputType == InputType.CONTROLLER) this.mc.controllerInput.buttonA.cancelButtonPress();
 
                 break;
             case 5:
-                mc.displayScreen(new ScreenAchievements(this, mc.statsCounter));
+                this.mc.displayScreen(new ScreenAchievements(this, this.mc.statsCounter));
                 break;
             case 6:
-                mc.displayScreen(new ScreenStats(this, mc.statsCounter));
+                this.mc.displayScreen(new ScreenStats(this, this.mc.statsCounter));
                 break;
             case 7:
-                mc.displayScreen(new ScreenPhotoMode());
+                this.mc.displayScreen(new ScreenPhotoMode());
                 break;
             case 9:
-                mc.displayScreen(new ScreenOptions(this, OptionsPages.DEBUG));
+                this.mc.displayScreen(new ScreenOptions(this, OptionsPages.DEBUG));
                 break;
             case 10:
                 UrlHelper.openURL("https://bugs.betterthanadventure.net/");
@@ -100,37 +96,29 @@ public class ScreenPause extends Screen
     }
 
     @Override
-	public void tick()
-    {
+    public void tick() {
         super.tick();
-        updateCounter++;
+        this.tickCount++;
+        this.saving = !this.mc.currentWorld.pauseScreenSave(this.tickCount);
     }
 
     @Override
-	public void render(int mx, int my, float partialTick)
-    {
+    public void render(int mx, int my, float partialTick) {
         I18n i = I18n.getInstance();
         renderBackground();
-        if(mc == null || mc.currentWorld == null) {
-        	mc.displayScreen(null);
-        	return;
+        if (this.mc.currentWorld == null) {
+            this.mc.displayScreen(null);
+            return;
         }
-        boolean isSaving = !mc.currentWorld.pauseScreenSave(updateCounter2++);
-        if(isSaving || updateCounter < 20)
-        {
-            float f1 = ((float)(updateCounter % 10) + partialTick) / 10F;
-            f1 = MathHelper.sin(f1 * MathHelper.PI * 2.0F) * 0.2F + 0.8F;
-            int k = (int)(255F * f1);
-            drawStringShadow(fontRenderer, i.translateKey("gui.ingame_menu.label.saving"), 8, height - 16, k << 16 | k << 8 | k);
+
+        if (this.saving) {
+            float brightness = ((float) (this.tickCount % 10) + partialTick) / 10F;
+            brightness = MathHelper.sin(brightness * MathHelper.PI * 2.0F) * 0.2F + 0.8F;
+            drawStringShadow(this.fontRenderer, i.translateKey("gui.ingame_menu.label.saving"), 8, this.height - 16, Color.floatToIntARGB(1f, brightness, brightness, brightness));
         }
-        drawStringCenteredShadow(fontRenderer, i.translateKey("gui.ingame_menu.label.title"), width / 2, 40, 0xffffff);
-        String score = TextFormatting.YELLOW.toString() + mc.thePlayer.getScore();
-        drawStringCenteredShadow(fontRenderer, i.translateKeyAndFormat("gui.ingame_menu.label.score", score), width / 2, 56, 0xfefefe);
+        drawStringCenteredShadow(this.fontRenderer, i.translateKey("gui.ingame_menu.label.title"), this.width / 2, 40, 0xffffff);
+        String score = TextFormatting.YELLOW.toString() + this.mc.thePlayer.getScore();
+        drawStringCenteredShadow(this.fontRenderer, i.translateKeyAndFormat("gui.ingame_menu.label.score", score), this.width / 2, 56, 0xfefefe);
         super.render(mx, my, partialTick);
     }
-
-    private int updateCounter2;
-    private int updateCounter;
-
-    public static boolean photoModeDisabled = false;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 0247b7971..fc6c28c5c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -341,7 +341,7 @@ public class HudIngame extends Gui
                     debugOffset += space;
 
                     Block<?> block = Blocks.blocksList[mc.currentWorld.getBlockId(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z)];
-                    if (block.id() > 0 && block.id() < Blocks.blocksList.length) {
+                    if (block != null) {
                         drawDebugScreenLineRight("Looking at:");
 
                         String name;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 1bd9c7592..f0f811d09 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -359,6 +359,7 @@ public abstract class OptionsPages
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.enableDevResourceLoading))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.devModels))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.enableMultiDrawRendering))
+                .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.enableThreadedChunkProvider))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.doJCECheck))
             )
             .withComponent(new OptionsCategory("gui.options.page.debug.category.utility")
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index 3143dca81..d7cf32df4 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -23,6 +23,7 @@ import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.option.enums.Colorblindness;
 import net.minecraft.client.render.font.Fonts;
 import net.minecraft.client.option.enums.DescriptionPromptEnum;
+import net.minecraft.client.world.chunk.provider.SelectedProvider;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.ChatVisibility;
 import net.minecraft.core.enums.Difficulty;
@@ -143,6 +144,7 @@ public class GameSettings {
 	public @NotNull OptionBoolean turnWithVehicle = new OptionBoolean(this, "turnWithVehicle", true);
 	public @NotNull OptionBoolean disableCrashHandler = new OptionBoolean(this, "disableCrashHandler", false);
 	public @NotNull OptionBoolean enableMultiDrawRendering = new OptionBoolean(this, "enableMultiDrawRendering", true);
+	public @NotNull OptionEnum<SelectedProvider> enableThreadedChunkProvider = new OptionEnum<>(this, "enableThreadedChunkProvider", SelectedProvider.class, SelectedProvider.THREADED);
 	public @NotNull OptionBoolean musicToasts = new OptionBoolean(this, "musicToasts", true);
 	public @NotNull OptionEnum<MusicFrequency> musicFrequency = new OptionEnum<>(this, "musicFrequency", MusicFrequency.class, MusicFrequency.DEFAULT);
 
@@ -190,6 +192,8 @@ public class GameSettings {
 	public @NotNull OptionBoolean enableHolidayTextures = new OptionBoolean(this, "enableHolidayTextures", true);
 	public @NotNull OptionBoolean dynamicCursor = new OptionBoolean(this, "dynamicCursor", true);
 	public @NotNull OptionBoolean devModels = new OptionBoolean(this, "devModels", true);
+	public @NotNull OptionBoolean doJCECheck = new OptionBoolean(this, "doJCECheck", true);
+	public @NotNull OptionString uuidServer = new OptionString(this, "uuidServer", "https://api.minecraftservices.com/minecraft/profile/lookup/name/%s");
 
 	public @NotNull OptionBoolean playerLeftHanded = new OptionBoolean(this, "player.left.handed", false);
 	public @NotNull OptionBoolean playerCape = new OptionBoolean(this, "player.cape", true);
@@ -201,8 +205,6 @@ public class GameSettings {
 	public @NotNull OptionBoolean playerPantRight = new OptionBoolean(this, "player.pant.right", true);
 	public @NotNull OptionBoolean playerDevModel = new OptionBoolean(this, "player.devmodel", true);
 	public @NotNull OptionEnum<Player.PlayerConfig.HurtSound> playerHurtSound = new OptionEnum<>(this, "player.hurtsound", Player.PlayerConfig.HurtSound.class, Player.PlayerConfig.HurtSound.MASCULINE);
-	public @NotNull OptionBoolean doJCECheck = new OptionBoolean(this, "doJCECheck", true);
-	public @NotNull OptionString uuidServer = new OptionString(this, "uuidServer", "https://api.minecraftservices.com/minecraft/profile/lookup/name/%s");
 
 	public @NotNull KeyBinding keyAttack = new KeyBinding("key.attack").setDefault(InputDevice.mouse, 0);
 	public @NotNull KeyBinding keyInteract = new KeyBinding("key.interact").setDefault(InputDevice.mouse, 1);
@@ -537,6 +539,7 @@ public class GameSettings {
 			if (discordRichPresence.value && mc.rpcThread == null)
 			{
 				mc.rpcThread = new RichPresenceHandlerThread(mc);
+				mc.rpcThread.setName("Discord RPC Thread");
 				mc.rpcThread.start();
 			}
 		}
diff --git a/game/client/src/main/java/net/minecraft/client/render/DirtyChunkRendererSorter.java b/game/client/src/main/java/net/minecraft/client/render/DirtyChunkRendererSorter.java
index 91b34646a..2f2d0adfa 100644
--- a/game/client/src/main/java/net/minecraft/client/render/DirtyChunkRendererSorter.java
+++ b/game/client/src/main/java/net/minecraft/client/render/DirtyChunkRendererSorter.java
@@ -2,50 +2,72 @@ package net.minecraft.client.render;
 
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.terrain.ChunkRenderer;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Comparator;
 
 public class DirtyChunkRendererSorter
-    implements Comparator<ChunkRenderer>
-{
+    implements Comparator<@NotNull ChunkRenderer> {
 
-    public DirtyChunkRendererSorter(ICamera activeCamera)
-    {
-        this.activeCamera = activeCamera;
+    private @Nullable ICamera activeCamera;
+
+    public DirtyChunkRendererSorter() {
+
+    }
+
+    public void setActiveCamera(@NotNull ICamera camera) {
+        this.activeCamera = camera;
     }
 
+//    @Override
+//    public int compare(@NotNull ChunkRenderer cr1, @NotNull ChunkRenderer cr2) {
+//        double cr1Distance = cr1.distanceToCameraSquared(this.activeCamera);
+//        double cr2Distance = cr2.distanceToCameraSquared(this.activeCamera);
+//        if (cr2Distance > 2048 && cr1Distance > 2048) {
+//            boolean cr1InFrustum = cr1.visible;
+//            boolean cr2InFrustum = cr2.visible;
+//            if (cr2 == cr1) {
+//                return 0;
+//            }
+//            if (cr2InFrustum && !cr1InFrustum) {
+//                return 1;
+//            }
+//            if (cr1InFrustum && !cr2InFrustum) {
+//                return -1;
+//            }
+//        }
+//        if (cr2Distance < cr1Distance) {
+//            return 1;
+//        }
+//        if (cr2Distance > cr1Distance) {
+//            return -1;
+//        }
+//        return cr2.id >= cr1.id ? -1 : 1;
+//    }
+
     @Override
-    public int compare(ChunkRenderer cr1, ChunkRenderer cr2)
-    {
+    public int compare(@NotNull ChunkRenderer cr1, @NotNull ChunkRenderer cr2) {
         boolean cr1InFrustum = cr1.visible;
         boolean cr2InFrustum = cr2.visible;
-        if (cr1.equals(cr2))
-        {
+        if (cr1 == cr2) {
             return 0;
         }
-        if(cr1InFrustum && !cr2InFrustum)
-        {
+        if (cr1InFrustum && !cr2InFrustum) {
             return 1;
         }
-        if(cr2InFrustum && !cr1InFrustum)
-        {
+        if (cr2InFrustum && !cr1InFrustum) {
             return -1;
         }
         double cr1Distance = cr1.distanceToCameraSquared(activeCamera);
         double cr2Distance = cr2.distanceToCameraSquared(activeCamera);
-        if(cr1Distance < cr2Distance)
-        {
+        if (cr1Distance < cr2Distance) {
             return 1;
         }
-        if(cr1Distance > cr2Distance)
-        {
+        if (cr1Distance > cr2Distance) {
             return -1;
-        }
-        else
-        {
+        } else {
             return cr1.id >= cr2.id ? -1 : 1;
         }
     }
-
-    private final ICamera activeCamera;
 }
